unit demou;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, PCSC,ShellAPI, ExtCtrls, ComCtrls;

type
  TForm1 = class(TForm)
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    Memo1: TMemo;
    Button1: TButton;
    APDUCard1: TAPDUDemoCard;
    Panel1: TPanel;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    Edit1: TEdit;
    Edit2: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    Button5: TButton;
    Memo2: TMemo;
    Label3: TLabel;
    CheckBox1: TCheckBox;
    RadioGroup3: TRadioGroup;
    RadioGroup1: TRadioGroup;
    procedure Button1Click(Sender: TObject);
    procedure APDUCard1ReaderNameChange(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure CheckBox1Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure APDUCard1Connected(Sender: TObject; Reader: TSmartcardReader;
      State: TReaderState);
    procedure APDUCard1Disconnected(Sender: TObject;
      Reader: TSmartcardReader; State: TReaderState);
    procedure APDUCard1CardAbsent(Sender: TObject;
      Reader: TSmartcardReader; State: TReaderState);
    procedure APDUCard1CardSwallowed(Sender: TObject;
      Reader: TSmartcardReader; State: TReaderState);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.Button1Click(Sender: TObject);
begin
 APDUCard1.SelectReader;
end;

procedure TForm1.APDUCard1ReaderNameChange(Sender: TObject);
begin
 memo2.lines.Clear;
 memo2.lines.ADD(apducard1.readername);
 memo2.lines.ADD('[reader info]');
 memo2.lines.ADD(ReaderStateToString(apducard1.ReaderState));
 memo2.lines.ADD(apducard1.AtrString);
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
 ShellExecute(0,'OPEN','http://friko3.onet.pl/ld/vizyp/delphi.htm','','',SW_SHOW);
end;

procedure TForm1.CheckBox1Click(Sender: TObject);
begin
 apducard1.autoreset:=checkbox1.checked;
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
 case radiogroup3.ItemIndex of
  0:apducard1.Connect(sm_Direct,pr_default);
  1:apducard1.Connect(sm_Shared,pr_default);
  2:apducard1.Connect(sm_Exclusive,pr_default);
 end;
end;

procedure TForm1.Button6Click(Sender: TObject);
begin
 ShowMessage('Select connection mode');
end;

procedure TForm1.Button4Click(Sender: TObject);
begin
 try
  apducard1.Command.hex:=edit1.text;
 except
  on Exception do begin
   ShowMessage('The command is in wrong format. Should be in hex format, eg. A0 05 01 23 40 60');
   exit;
  end;
 end;
 if apducard1.TransmitAndCheck = apduerr_OK then
  edit2.text:='Answer:'+apducard1.Answer.Hex+'['+apducard1.ResultDescription+']'
 else
  edit2.text:='Transmission failed. Error:'+apducard1.ResultDescription;
end;

procedure TForm1.Button5Click(Sender: TObject);
begin
 case radiogroup1.ItemIndex of
  0:apducard1.Disconnect(cd_Leave);
  1:apducard1.Disconnect(cd_Reset);
  2:apducard1.Disconnect(cd_Unpower);
  3:apducard1.Disconnect(cd_Eject);
  4:apducard1.Disconnect(cd_Swallow);
 end;
end;

procedure TForm1.APDUCard1Connected(Sender: TObject;
  Reader: TSmartcardReader; State: TReaderState);
begin
 memo2.lines[1]:='Vendor name:'+Reader.Attribute[SCARD_ATTR_VENDOR_NAME].Str+' Channel:COM'+IntToHex(reader.Attribute[SCARD_ATTR_CHANNEL_ID].Byte,2);
 memo2.lines[2]:= ReaderStateToString(state);
end;

procedure TForm1.APDUCard1Disconnected(Sender: TObject;
            Reader: TSmartcardReader; State: TReaderState);
begin
 memo2.lines.Clear;
 memo2.lines.ADD(apducard1.readername);
 memo2.lines.ADD('Not connected');
 memo2.lines.ADD(ReaderStateToString(apducard1.ReaderState));
 memo2.lines.ADD(apducard1.AtrString);
end;

procedure TForm1.APDUCard1CardAbsent(Sender: TObject;
  Reader: TSmartcardReader; State: TReaderState);
begin
 memo2.lines[3]:='';
 memo2.lines[2]:= ReaderStateToString(state);
end;

procedure TForm1.APDUCard1CardSwallowed(Sender: TObject;
  Reader: TSmartcardReader; State: TReaderState);
begin
 memo2.lines[3]:=apducard1.AtrString;
 memo2.lines[2]:= ReaderStateToString(state);
end;

end.
